#!/bin/bash

. /etc/rc.conf
. /stc/rc.d/functions

PID=`pidof -o %PPID /usr/bin/icon-de`

case $1 in
  start)
    stat_busy "Starting icon-de..."
    [ -z "$PID" ] && /usr/bin/icon-de &> /dev/null
    if [ $? -gt 0 ]; then
      stat_fail
    else
      add_daemon icon-de
      stat_done
    fi
    ;;

  stop)
    stat_busy "Stopping icon-de..."
    [ ! -z "$PID" ] && kill $PID &> /dev/null
    if [ $? -gt 0 ]; then
      stat_fail
    else
      rm_daemon icon-de
      stat_done
    fi
    ;;

  restart)
    $0 stop
    sleep 3
    $0 start
    ;;

  *)
    echo "Usage: $0 {start|stop|restart}"
    ;;
esac
exit 0

# End of file
